"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Context = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _initializerDefineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerDefineProperty"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));
var _initializerWarningHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerWarningHelper"));
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _lowcodeTypes = require("@alilc/lowcode-types");
var _mobx = require("mobx");
var _baseContext = require("./base-context");
var _webview = require("../inner-plugins/webview");
var _class, _descriptor, _descriptor2;
var Context = (_class = /*#__PURE__*/function (_BasicContext) {
  (0, _inheritsLoose2["default"])(Context, _BasicContext);
  function Context(workspace, editorWindow, editorView, options) {
    var _this;
    _this = _BasicContext.call(this, workspace, editorView.viewName, _lowcodeTypes.IPublicEnumPluginRegisterLevel.EditorView, editorWindow) || this;
    _this.workspace = workspace;
    _this.editorWindow = editorWindow;
    _this.editorView = editorView;
    _this.viewName = 'editor-view';
    _this.instance = void 0;
    _this.viewType = void 0;
    (0, _initializerDefineProperty2["default"])(_this, "_activate", _descriptor, (0, _assertThisInitialized2["default"])(_this));
    (0, _initializerDefineProperty2["default"])(_this, "isInit", _descriptor2, (0, _assertThisInitialized2["default"])(_this));
    _this.init = (0, _mobx.flow)( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _this$instance2, _this$instance2$init;
      var _this$instance, _this$instance$url, url;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (!(this.viewType === 'webview')) {
              _context.next = 8;
              break;
            }
            _context.next = 3;
            return (_this$instance = this.instance) === null || _this$instance === void 0 ? void 0 : (_this$instance$url = _this$instance.url) === null || _this$instance$url === void 0 ? void 0 : _this$instance$url.call(_this$instance);
          case 3:
            url = _context.sent;
            _context.next = 6;
            return this.plugins.register((0, _webview.getWebviewPlugin)(url, this.viewName));
          case 6:
            _context.next = 10;
            break;
          case 8:
            _context.next = 10;
            return this.registerInnerPlugins();
          case 10:
            _context.next = 12;
            return (_this$instance2 = this.instance) === null || _this$instance2 === void 0 ? void 0 : (_this$instance2$init = _this$instance2.init) === null || _this$instance2$init === void 0 ? void 0 : _this$instance2$init.call(_this$instance2);
          case 12:
            _context.next = 14;
            return this.innerPlugins.init();
          case 14:
            this.isInit = true;
          case 15:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    _this.onSimulatorRendererReady = function () {
      return new Promise(function (resolve) {
        _this.project.onSimulatorRendererReady(function () {
          resolve();
        });
      });
    };
    _this.setActivate = function (_activate) {
      _this._activate = _activate;
      _this.innerHotkey.activate(_this._activate);
    };
    _this.viewType = editorView.viewType || 'editor';
    _this.viewName = editorView.viewName;
    _this.instance = editorView(_this.innerPlugins._getLowCodePluginContext({
      pluginName: 'any'
    }), options);
    (0, _lowcodeEditorCore.makeObservable)((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }
  var _proto = Context.prototype;
  _proto.save = /*#__PURE__*/function () {
    var _save = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var _this$instance3, _this$instance3$save;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (_this$instance3 = this.instance) === null || _this$instance3 === void 0 ? void 0 : (_this$instance3$save = _this$instance3.save) === null || _this$instance3$save === void 0 ? void 0 : _this$instance3$save.call(_this$instance3);
          case 2:
            return _context2.abrupt("return", _context2.sent);
          case 3:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function save() {
      return _save.apply(this, arguments);
    }
    return save;
  }();
  (0, _createClass2["default"])(Context, [{
    key: "active",
    get: function get() {
      return this._activate;
    }
  }]);
  return Context;
}(_baseContext.BasicContext), (_descriptor = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "_activate", [_lowcodeEditorCore.obx], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "isInit", [_lowcodeEditorCore.obx], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "active", [_lowcodeEditorCore.computed], Object.getOwnPropertyDescriptor(_class.prototype, "active"), _class.prototype)), _class);
exports.Context = Context;