"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
var _exportNames = {
  EditorView: true
};
exports.EditorView = void 0;
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _lowcodeDesigner = require("@alilc/lowcode-designer");
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _lowcodeEditorSkeleton = require("@alilc/lowcode-editor-skeleton");
var _react = require("react");
var _baseContext = require("../context/base-context");
Object.keys(_baseContext).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _baseContext[key]) return;
  exports[key] = _baseContext[key];
});
var _class;
var EditorView = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(EditorView, _PureComponent);
  function EditorView() {
    return _PureComponent.apply(this, arguments) || this;
  }
  var _proto = EditorView.prototype;
  _proto.render = function render() {
    var active = this.props.active;
    var editorView = this.props.editorView;
    var skeleton = editorView.innerSkeleton;
    if (!editorView.isInit) {
      var Loading = _lowcodeEditorCore.engineConfig.get('loadingComponent', _lowcodeDesigner.BuiltinLoading);
      return /*#__PURE__*/React.createElement(Loading, null);
    }
    return /*#__PURE__*/React.createElement(_lowcodeEditorSkeleton.Workbench, {
      skeleton: skeleton,
      className: active ? 'active engine-editor-view' : 'engine-editor-view',
      topAreaItemClassName: "engine-actionitem"
    });
  };
  return EditorView;
}(_react.PureComponent)) || _class;
exports.EditorView = EditorView;